﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.Touch;
using Infragistics.Win.UltraWinTabControl;
using Infragistics.Win;

namespace TabSwipeExample
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            this.ultraTabControl1.GestureQueryStatus += new Infragistics.Win.Touch.GestureQueryStatusHandler(ultraTabControl1_GestureQueryStatus);
            this.ultraTabControl1.PanGesture += new Infragistics.Win.Touch.PanGestureHandler(ultraTabControl1_PanGesture);
            this.ultraTabControl1.GestureStarting += new GestureStartingHandler(ultraTabControl1_GestureStarting);
            this.ultraTabControl1.GestureCompleted += new GestureCompletedHandler(ultraTabControl1_GestureCompleted);
        }

        void ultraTabControl1_GestureCompleted(object sender, GestureCompletedEventArgs e)
        {
            if (e.Gesture == Gesture.Pan)
            {
                startingLocation = Point.Empty;
            }
        }

        private Point startingLocation = Point.Empty;
        void ultraTabControl1_GestureStarting(object sender, GestureStartingEventArgs e)
        {
            if (e.Gesture == Gesture.Pan)
            {
                startingLocation = e.Location;
            }
        }

        private void ultraTabControl1_GestureQueryStatus(object sender, Infragistics.Win.Touch.GestureQueryStatusEventArgs e)
        {
            e.Mode = GestureModes.Pan;
        }

        private void ultraTabControl1_PanGesture(object sender, Infragistics.Win.Touch.PanGestureEventArgs e)
        {
            ProcessTabHeaderPan(e);
        }

        private const int threshold = 50;
        private void ProcessTabHeaderPan(PanGestureEventArgs e)
        {
            int delta = (e.Location.X - startingLocation.X);
            if (Math.Abs(delta) < threshold)
            {
                return;
            }
            
            bool right = delta > 0;
            
            if (right)
            {
                UltraTab selectedTab = this.ultraTabControl1.SelectedTab;
                int newIndex = selectedTab.Index + 1;
                if (newIndex >= this.ultraTabControl1.Tabs.Count)
                {
                    newIndex = 0;
                }
                this.ultraTabControl1.Tabs[newIndex].Selected = true;
                startingLocation = e.Location;
            }
            else
            {
                UltraTab selectedTab = this.ultraTabControl1.SelectedTab;
                int newIndex = selectedTab.Index - 1;
                if (newIndex < 0)
                {
                    newIndex = this.ultraTabControl1.Tabs.Count - 1;
                }
                this.ultraTabControl1.Tabs[newIndex].Selected = true;
                startingLocation = e.Location;
            }
        }
    }
}
